"""
 #  num-muti :: deps_numer 公集
 @  E.C.Ares
 !  MIT DIVIƷON
 `  __deps_ builtin numer-python 蟒算
"""
# r
import basic as bas
cet_imp = bas.cet_imp
exec(cet_imp())

from typing          import Union,Optional

# s
TYP  =  CPD(bas.TYP) # 是一个class, 而非实例 FIXME
# FIXME Jax
TZL=TAL.rec('Z')

_fc  = TZL['FC_IMP']
if  bas.bet(_fc,NON) or _fc== '': _fc='tn'
if 'j' in _fc:
    import jax       as nmb
    import jax.numpy as nmp
    import jax.nn    as nmm
if 'h' in _fc:
    pass
    #import haiku     as nmm
if 't' in _fc:
    import  torch    as nmb
    import  torch.nn as nmm
    import  torch.distributions as dal
    _LC_DEV='cuda'if nmb.cuda.is_available()else'cpu'
    # FIXME: multi-GPU
    class DOX(TYP._YM): 
      DEV  =  nmb.device( _LC_DEV)
      DEC  =  nmb.device('cpu')
      DEG  =  nmb.device('cuda')
      DE0  =  nmb.device('cuda:0')
      DEI  =  lambda i:\
              nmb.device(f'cuda:{i}')
    class NYA(TYP._UM):
      IDT=nmm.Identity
      LIN=nmm.Linear
      C1N=nmm.Conv1d
      C2N=nmm.Conv2d
      C3N=nmm.Conv3d
      G1N=nmm.ConvTranspose1d   #G=CT
      G2N=nmm.ConvTranspose2d
      G3N=nmm.ConvTranspose3d
      d1n  =  nmm.Dropout
      d2n  =  nmm.Dropout2d
      d3n  =  nmm.Dropout3d
      b1n  =  nmm.BatchNorm1d
      b2n  =  nmm.BatchNorm2d
      b3n  =  nmm.BatchNorm3d
      lrn  =  nmm.LayerNorm
      gdn  =  nmm.GroupNorm
      emb  =  nmm.Embedding
      # 激活函数
      TRH=nmm.   Threshold   # 顶截割
      TAN=nmm.   Tanh        # 顶切全:双曲正切
      TAH=nmm.   Hardtanh    # 顶切割
      SPL=nmm.   Softplus
      SFS=nmm.   Softsign
      SFV=nmm.   Softmin
      SFM=nmm.   Softmax
      S2M=nmm.   Softmax2d
      SLM=nmm.LogSoftmax
      ReL=nmm.     ReLU
      R6L=nmm.     ReLU6
      RlL=nmm.LeakyReLU
      RpL=nmm.    PReLU
      ExL=nmm.      ELU
      EsL=nmm.     SELU
      EcL=nmm.     CELU
      EgL=nmm.     GELU
      GaL=nmm.      GLU
      SiL=nmm.     SiLU
      SIG=nmm.   Sigmoid
      SLG=nmm.LogSigmoid
      IHʃ=nmm.Hardshrink    
      SFʃ=nmm.Softshrink
      TAʃ=nmm.Tanhshrink
      MHA=nmm.MultiheadAttention
      #LOSS
      HEL=nmm.HingeEmbeddingLoss
      MRL=nmm.MarginRankingLoss
      MML=nmm.MultiMarginLoss
      LML=nmm.MultiLabelMarginLoss
      SML=nmm.SoftMarginLoss
      LSL=nmm.MultiLabelSoftMarginLoss
      SLL=nmm.SmoothL1Loss
      GNL=nmm.GaussianNLLLoss
      HBL=nmm.HuberLoss
      CEL=nmm.CrossEntropyLoss
      
    TYP.ΛUT =  Optional[nmb.dtype]  # []内数据类型，而非结构   
    TYP._3B = nmb.bool
    TYP._3O = nmb.uint8
    TYP._30 = nmb.int8    # 2^0 * 8
    TYP._31 = nmb.short   # 2^1 * 8
    TYP._33 = nmb.long    # 2^3 * 8
    TYP._3P = nmb.bfloat16
    TYP._3D = nmb.double
    TYP._3k = nmb.complex64
    TYP._3K = nmb.complex128
if 'n' in _fc:
    import numpy     as nmp
# numpy
TYP.Λ2X = nmp.ndarray
TYP.N2X = nmp.object_
TYP._2B = nmp.bool_
TYP._2O = nmp.uint8
TYP._20 = nmp.int8   # 2 ^ 0 * 8
TYP._21 = nmp.short  # 2 ^ 1 * 8
TYP._22 = nmp.int32  # 2 ^ 2 * 8
TYP._23 = nmp.int64  # 2 ^ 3 * 8
#TYP._24= nmp.int128 # 2 ^ 4 * 8
#TYP._25= nmp.int256 # 2 ^ 5 * 8
TYP._2P = nmp.float16
TYP._2f = nmp.float32
TYP._2D = nmp.float64
TYP._2k = nmp.complex64
TYP._2K = nmp.complex128
TYP.NMP=TYB._0G(dict(
      b=TYB._0G({ 
         32:bool       ,
         64:bool       ,
        'c':bool       }),
      u=TYB._0G({
          8:TYP._2O    ,
         16:nmp.uint16 ,
         32:nmp.uint32 ,
         64:nmp.uint64 ,
        'c':nmp.uintc  , 
      # 128:nmp.uint128,
      # 256:nmp.uint256,
        'p':nmp.uintp  }),
      i=TYB._0G({
         8 :TYP._20    ,
         16:TYP._21    ,
         32:TYP._22    ,
         64:TYP._23    ,
        'c':nmp.intc   ,
      # 128:nmp.int128 ,
      # 256:nmp.int256 ,
        'p':nmp.intp   }),
      f=TYB._0G({
        #8 :nmp.float8_e5m2,
         16:TYP._2P    ,
         32:TYP._2f    ,
         64:TYP._2D    ,
        'c':TYP._2D    ,
      #  80:nmp.float80,
      #  96:nmp.float96,
      # 128:nmp.float128,
      # 256:nmp.float256
        'p':nmp.float_ }),
      c=TYB._0G({64:TYP._2k    ,
        'c':TYP._2k    ,
        128:TYP._2K    ,
      # 160:nmp.complex160,
      # 192:nmp.complex192,
      # 256:nmp.complex256,
      # 512:nmp.complex512,
        'p':nmp.complex_}),
      s=TYB._0G({0 :str,
        'c':str,
        'p':str})))
# torch or jax
TYP._3I = nmb.int
TYP._3d = nmb.float
TYP.Λ3X = nmb.Tensor
TYP.M3X = nmm.Module
#TYP.T3X= tensordict
#TYP.D3X= nmb.utils.data.Dataset
#TYP.L3X= nmb.utils.data.DataLoader
#TYP.O3X= nmb.optim.Optimizer
TYP._3H = nmm.Parameter
TYP.Λ3W = nmm.Sequential
TYP.A3W = nmm.ModuleList
TYP.T3W = nmm.ModuleDict
TYP.A3H = nmm.ParameterList
TYP.T3H = nmm.ParameterDict
TYP.N3X = Union[TYP.Λ3X,TYP.M3X]
#TYP    = TypedDict('TYP', TYP)\ frozendict(TYP)
# t
bet     = bas.bet

'''
def setnImp(_fc='j'):
  if bas.bet(_fc,NON) or _fc== '': _fc='tn'
  if 'j' in _fc:
    import jax       as nmb
    import jax.numpy as nmp
    import jax.nn    as nmm
  if 'h' in _fc:
    import haiku     as nmm
  if 't' in _fc:
    import torch     as nmb
    import torch.nn  as nmm
  if 'n' in _fc:
    import numpy     as nmp
setnImp( VAR( 'FC_IMP'))
'''

#tmod = lambda x: nmb.transform(x) if else
#t1   = lambda y: y
    
if bas.Her(__name__):
    print('ddd')