from .__deps_ import *
from typing    import Any, Optional, Tuple


def detrRan(seed: Optional[int] = None, fc=FRB) -> Tuple[nmp.random.Generator, Any]:
    if seed is not None and not (isinstance(seed, int) and 0 <= seed):
        raise error.Error(f"Seed must be a non-negative integer or omitted, not {seed}")

    seed_seq = nmp.random.SeedSequence(seed)
    np_seed = seed_seq.entropy
    rng = RandomNumberGenerator(nmp.random.PCG64(seed_seq))
    return rng, np_seed


RNG = RandomNumberGenerator = nmp.random.Generator